var score_id = "cricketfox";
var tool_id="cricketpop";
var label_id="cricf-status-label";
var image_id="cricf-status-image";
var score_url = "http://www.cricinfo.com/rss/livescores.xml";
var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
var alertService = Components.classes["@mozilla.org/alerts-service;1"].getService(Components.interfaces.nsIAlertsService);
// This is our javascript

var objCricketFox = null;

function cfLoad() {
	objCricketFox = new CricketFox();
	objCricketFox.lastUpdate.setDate(objCricketFox.lastUpdate.getDate()-5);
	objCricketFox.do_score();
}

function trimString (str) {
  str = this != window? this : str;
  return str.replace(/^\s+/g, '').replace(/\s+$/g, '');
}

function CricketFox () {
	
	return this;
}

function cfLoadOptions() {
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                       .getService(Components.interfaces.nsIWindowMediator);
    var win = wm.getMostRecentWindow("Cricketfox:Options");
    if (win) {
		win.focus();
	} else {
		openDialog("chrome://cricketfox/content/options.xul", "", "chrome,titlebar,toolbar,centerscreen,modal");
	}
}

CricketFox.prototype =
{
	lastUpdate:new Date(),
	favTeam:prefService.getCharPref("extensions.cricketfox.favTeam"),
	secTeam:prefService.getCharPref("extensions.cricketfox.secondaryTeam"),
	request: null,
	nextToShow:0,
	
	do_score: function(){
		objCricketFox.favTeam = prefService.getCharPref("extensions.cricketfox.favTeam");
		objCricketFox.secTeam = prefService.getCharPref("extensions.cricketfox.secondaryTeam");
		this.load_xml(score_url);
		setTimeout("objCricketFox.do_score()", prefService.getIntPref("extensions.cricketfox.updateInterval"));
	},

	// Adapted from the good people at ADC:
	// http://developer.apple.com/internet/webcontent/xmlhttpreq.html
	// this starts loading the XML data and sets up the process_request handler.
	load_xml: function(url)
	{
		
		var module = this;
		this.request = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance(Components.interfaces.nsIXMLHttpRequest);;
	    this.request.open("GET", url, true);
		this.request.overrideMimeType("text/xml");
	    this.request.onload = function() { module.process_request(this.responseXML, this.status) };
		this.request.onerror = function() { module.process_error() };
    	try {
	      if (this.request.channel instanceof Components.interfaces.nsISupportsPriority)
    	    this.request.channel.priority = Components.interfaces.nsISupportsPriority.PRIORITY_HIGHEST;
	    } catch(e) {};
        this.request.send(null);	
	},

	process_error: function(){
		document.getElementById(image_id).setAttribute("src","chrome://cricketfox/skin/images/cficonerr.png");
		document.getElementById(image_id).setAttribute("hidden","false");
		document.getElementById(label_id).setAttribute("hidden","true");
		
		var parent = document.getElementById("cricketpop");
		//Get old tooltip so that it can be replaced
		var oldTooltip = document.getElementById("scoretip");
		var tooltip = document.createElement("tooltip");
		tooltip.setAttribute("id", "scoretip");
		tooltip.setAttribute("orient","horizontal");
		tooltip.setAttribute("noautohide", "true");

		//Create the score labels
		var lblparent = document.createElement("vbox");

		var lbl = document.createElement("label");
		lbl.setAttribute("crop", "right");
		lbl.setAttribute("value", "Unable to contact live score feed.");
		
		var lbl1 = document.createElement("label");
		lbl1.setAttribute("crop", "right");
		lbl1.setAttribute("value", "Leave feedback at cricketfox.mozdev.org if problem persists");
		
		lblparent.appendChild(lbl);
		lblparent.appendChild(lbl1);
		
		tooltip.appendChild(lblparent); 
		
		parent.replaceChild(tooltip,oldTooltip);    
		document.getElementById(score_id).setAttribute("tooltip","scoretip");
	},
	// This function is called once the request state changes.  It pulls the
	// relevant data from the response and sends to update_count().
	process_request: function(response, aStatus)
	{
		if (!response || aStatus > 200) {
	      return;
	    };
		var pubDate = Date.parse(response.getElementsByTagName('pubDate')[0].firstChild.data);
		var items = response.getElementsByTagName('item');
		var foundMatch = 0;
		var teamToMatch=new Array();
		if(objCricketFox.nextToShow==0||prefService.getIntPref("extensions.cricketfox.displayPreference")==0){
		//show favourite team's scores
			teamToMatch[0] = objCricketFox.favTeam;
			teamToMatch[1] = objCricketFox.secTeam;
			objCricketFox.nextToShow=1;
		}
		else{
			//Show secondary team's score
			teamToMatch[0] = objCricketFox.secTeam;
			teamToMatch[1] = objCricketFox.favTeam;
			objCricketFox.nextToShow=0;
		}
		for(var loop=0;loop < items.length;loop++){
			var title = items[loop].getElementsByTagName('title')[0].firstChild.data;
			if(title.match(teamToMatch[0])!=null){
				foundMatch = 1;
			//Match for your favourite team.
				var regex = new RegExp("\\([a-zA-Z0-9.'/\\s]*\\)","g");
				var newTitle = title.replace(regex,"");
				var cfteams = newTitle.split("Vs");
				var detailsLink = items[loop].getElementsByTagName('link')[0].firstChild.data;
				var linkregex = new RegExp("\\?OTC-RSS","g");
				detailsLink = detailsLink.replace(linkregex,"\?OTC-FOX");
				var cfteam1 = trimString(cfteams[0]);
				var cfteam2 = trimString(cfteams[1]);
				var isHomeBatting = 0;
				if(cfteam1.indexOf('*')!=-1){
				//First team batting, show their score
					isHomeBatting = 1;
					cfteam1 = cfteam1.substring(0,cfteam1.indexOf("*"));
					cfteam1 = trimString(cfteam1);
					objCricketFox.update_score(cfteam1,cfteam2,isHomeBatting,detailsLink);
				}
				else if(cfteam2.indexOf('*')!=-1){
				//Second team batting show them.	
					cfteam2 = trimString(cfteam2.substring(0,cfteam2.indexOf("*")));			
					objCricketFox.update_score(cfteam2,cfteam1,isHomeBatting,detailsLink);
				}
				else{
					objCricketFox.update_score(cfteam1+" - Match Yet to Start",cfteam2,1,detailsLink);
				}
			}
		}
		if(foundMatch==0){
			//Team we should be displaying isn't playing, try alternative
			for(var loop=0;loop < items.length;loop++){
				var title = items[loop].getElementsByTagName('title')[0].firstChild.data;
				if(title.match(teamToMatch[1])!=null){
					foundMatch = 1;
				//Match for your favourite team.
					var regex = new RegExp("\\([a-zA-Z0-9.'/\\s]*\\)","g");
					var newTitle = title.replace(regex,"");
					var cfteams = newTitle.split("Vs");
					var detailsLink = items[loop].getElementsByTagName('link')[0].firstChild.data;
					var linkregex = new RegExp("\\?OTC-RSS","g");
					detailsLink = detailsLink.replace(linkregex,"\?OTC-FOX");
					var cfteam1 = trimString(cfteams[0]);
					var cfteam2 = trimString(cfteams[1]);																				 
					var isHomeBatting = 0;
					if(cfteam1.indexOf('*')!=-1){
					//First team batting, show their score	
						isHomeBatting = 1;
						cfteam1 = trimString(cfteam1.substring(0,cfteam1.indexOf("*")));
						objCricketFox.update_score(cfteam1,cfteam2,isHomeBatting,detailsLink);
					}
					else if(cfteam2.indexOf('*')!=-1){
					//Second team batting show them.	
						cfteam2 = trimString(cfteam2.substring(0,cfteam2.indexOf("*")));			
						objCricketFox.update_score(cfteam2,cfteam1,isHomeBatting,detailsLink);
					}
					else{
					objCricketFox.update_score(cfteam1+" - Match Yet to Start",cfteam2,1,detailsLink);
					}
				}
			}			
		}
		if(foundMatch==0){
		//Neither team is playing. Display ball icon.
			document.getElementById(image_id).setAttribute("src","chrome://cricketfox/skin/images/cficonsmallest.png");
			document.getElementById(image_id).setAttribute("hidden","false");
			document.getElementById(label_id).setAttribute("hidden","true");
			
			var parent = document.getElementById("cricketpop");
			//Get old tooltip so that it can be replaced
			var oldTooltip = document.getElementById("scoretip");
			var tooltip = document.createElement("tooltip");
			tooltip.setAttribute("id", "scoretip");
			tooltip.setAttribute("orient","horizontal");
			tooltip.setAttribute("noautohide", "true");
	
			//Create the score labels
			var lblparent = document.createElement("vbox");
	
			var lbl = document.createElement("label");
			lbl.setAttribute("crop", "right");
			lbl.setAttribute("value", "Your selected teams aren't currently playing");
			
			lblparent.appendChild(lbl);
			
			tooltip.appendChild(lblparent); 
			
			parent.replaceChild(tooltip,oldTooltip);    
			document.getElementById(score_id).setAttribute("tooltip","scoretip");
		}
	},
	
	eventPopup: function (message) {
		var url = "http://localhost:8080/engSmall.png";
		var slogan = "WICKET!!";
		alertService.showAlertNotification(url,slogan, message,false,"",null);

	},

	update_score: function(battingTeam, otherTeam,isHomeBatting, detailsLink)
	{
  		var score = document.getElementById(score_id);
		//Set the visible label
 		document.getElementById(label_id).setAttribute("hidden","false");
		document.getElementById(image_id).setAttribute("hidden","true");
  		document.getElementById(label_id).setAttribute("value", battingTeam);
		score.setAttribute("ondblclick","window.open('"+detailsLink+"');");
		//Do the tooltip info
  		var parent = document.getElementById("cricketpop");
		//Get old tooltip so that it can be replaced
  		var oldTooltip = document.getElementById("scoretip");
	  	var tooltip = document.createElement("tooltip");
  		tooltip.setAttribute("id", "scoretip");
  		tooltip.setAttribute("orient","horizontal");
		tooltip.setAttribute("noautohide", "true");

		//Create the image
		var image = document.createElement("image");
		var icon = "chrome://cricketfox/skin/images/cficonsmall.png";
		image.setAttribute("src", icon);
		var imgparent = document.createElement("vbox");
	        imgparent.appendChild(image);
	
		//Create the score labels
  		var lblparent = document.createElement("vbox");

  		var lbl = document.createElement("label");
  		lbl.setAttribute("crop", "right");
	  	
  		var lbl1 = document.createElement("label");
  		lbl1.setAttribute("crop", "right");         
		if(isHomeBatting==1){
			lbl.setAttribute("value", battingTeam);
	  		lbl1.setAttribute("value", otherTeam);
		}       
		else{
			lbl.setAttribute("value", otherTeam);
	  		lbl1.setAttribute("value", battingTeam);
		}       
 	 	lblparent.appendChild(lbl);
  		lblparent.appendChild(lbl1);

  		tooltip.appendChild(imgparent); 
  		tooltip.appendChild(lblparent); 
		
  		parent.replaceChild(tooltip,oldTooltip);    
 		score.setAttribute("tooltip","scoretip");
	}
};