// JavaScript
var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
var teams_url = "http://cricketfox.mozdev.org/cfteams.xml";
function optionsLoad()
{
  gOptions = new OptionsModule();
  gOptions.loadPrefs();
}

function optionsUnload()
{
  gOptions = null;
}

function OptionsModule()
{
  this.wrappedJSObject = this;
  return this;
}

OptionsModule.prototype = {

	load_xml: function(url)
	{
		var module = this;
		this.request = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance(Components.interfaces.nsIXMLHttpRequest);
	    this.request.open("GET", url, true);
		this.request.overrideMimeType("text/xml");
	    this.request.onload = function() { module.process_request(this.responseXML, this.status) };
    	try {
	      if (this.request.channel instanceof Components.interfaces.nsISupportsPriority)
    	    this.request.channel.priority = Components.interfaces.nsISupportsPriority.PRIORITY_HIGHEST;
	    } catch(e) {};
        this.request.send(null);
	},
	
	process_request: function(response, aStatus)
	{
		if (!response || aStatus > 200) {
	      return;
	    };
		var teams = response.getElementsByTagName('team');
		favTeamMenu = document.getElementById("cf-teams");
		while (favTeamMenu.hasChildNodes())
			favTeamMenu.removeChild(favTeamMenu.lastChild);
		var favTeam = prefService.getCharPref("extensions.cricketfox.favTeam");
		var selIndex = 0;
		for(var loop=0;loop < teams.length;loop++){
			  var menuitem = document.createElement("menuitem");
			  var value = teams[loop].firstChild.data;
			  if(value == favTeam){
				selIndex=loop;
			  }
			  menuitem.setAttribute("label",value);
			  favTeamMenu.appendChild(menuitem);
		}
		secTeamMenu = document.getElementById("cf-teams2");
		while (secTeamMenu.hasChildNodes())
			secTeamMenu.removeChild(secTeamMenu.lastChild);
		var secTeam = prefService.getCharPref("extensions.cricketfox.secondaryTeam");
		var selSecIndex = 0;
		for(var loop=0;loop < teams.length;loop++){
			  var menuitem = document.createElement("menuitem");
			  var value = teams[loop].firstChild.data;
			  if(value == secTeam){
				selSecIndex=loop;
			  }
			  menuitem.setAttribute("label",value);
			  secTeamMenu.appendChild(menuitem);
		}
		var selInterval = 0;
		var favInterval = prefService.getIntPref("extensions.cricketfox.updateInterval")/60000;
		intervalMenu = document.getElementById("cf-interval").getElementsByTagName("menuitem");
		for(var loop=0;loop < intervalMenu.length;loop++){
			  var value = intervalMenu[loop].label;
			  if(value == favInterval){
				selInterval=loop;
			  }
		}
		var dispPref = prefService.getIntPref("extensions.cricketfox.displayPreference");
		if(dispPref==1){
			document.getElementById("cf-disp-rotate").setAttribute("selected",true);
		}
		else{
			document.getElementById("cf-disp-primary").setAttribute("selected",true);
		}
		document.getElementById("cf-interval-menulist").selectedIndex = selInterval;
		document.getElementById("cf-teams-menulist").selectedIndex = selIndex;
		document.getElementById("cf-teams2-menulist").selectedIndex = selSecIndex;
	},
	
	loadPrefs: function(){
		this.load_xml(teams_url);
	},
	
	buttonOk : function(){
		this.savePrefs();
	    window.close();
	},
	
	buttonCancel : function(){
		window.close();
	},
	
	savePrefs: function() {
		var selectedTeam = document.getElementById("cf-teams-menulist").selectedItem.label;
		var secondaryTeam = document.getElementById("cf-teams2-menulist").selectedItem.label;
		var updateInterval = document.getElementById("cf-interval-menulist").selectedItem.label;
		var selDisp = 0;
		if(document.getElementById("cf-disp-rotate").getAttribute("selected")){
			selDisp=1;
		}
		try{
			prefService.setCharPref("extensions.cricketfox.favTeam",selectedTeam);
		}catch(e){}
		try{
			prefService.setCharPref("extensions.cricketfox.secondaryTeam",secondaryTeam);
		}catch(e){}
		try{
			prefService.setIntPref("extensions.cricketfox.updateInterval",(updateInterval*60000));
		}catch(e){}
		try{
			prefService.setIntPref("extensions.cricketfox.displayPreference",selDisp);
		}catch(e){}		
	}
}